---
title: FileSystemHandle
slug: Web/API/FileSystemHandle
tags:
  - Directories
  - File System Access API
  - FileSystemHandle
  - Files
  - Interface
  - handle
  - working with files
---
<div>{{draft}}{{securecontext_header}}{{DefaultAPISidebar("File System Access API")}}</div>

<p class="summary">The <strong><code>FileSystemHandle</code></strong> interface of the {{domxref('File System Access API')}} is an object which represents an entry. Multiple handles can represent the same entry. For the most part you do not work with <code>FileSystemEntry</code> directly but rather it's child interfaces {{domxref('FileSystemFileEntry')}} and {{domxref('FileSystemDirectoryEntry')}}</p>

<h2 id="Interfaces_based_on_FileSystemHandle">Interfaces based on FileSystemHandle</h2>

<p>Below is a list of interfaces based on the FileSystemHandle interface.</p>

<dl>
 <dt>{{domxref("FileSystemFileEntry")}}</dt>
 <dd>Represents a handle to a file system entry.</dd>
 <dt>{{domxref("FileSystemDirectoryEntry")}}</dt>
 <dd>Provides a handle to a file system directory.</dd>
</dl>

<h2 id="Properties">Properties</h2>

<dl>
 <dt>{{domxref('FileSystemHandle.kind','kind')}} {{readonlyInline}}</dt>
 <dd>Returns the type of entry. This is <code>'file'</code> if the associated entry is a file or <code>'directory'</code>.</dd>
 <dt>{{domxref('FileSystemHandle.name', 'name')}} {{readonlyInline}}</dt>
 <dd>Returns the name of the associated entry.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<dl>
 <dt>{{domxref('FileSystemHandle.isSameEntry()', 'isSameEntry()')}}</dt>
 <dd>Compares two {{domxref("FileSystemHandle", "handles")}} to see if the associated entries (either a file or directory) match.</dd>
 <dt>{{domxref('FileSystemHandle.queryPermission()', 'queryPermission()')}}</dt>
 <dd>Queries the current permission state of the current handle.</dd>
 <dt>{{domxref('FileSystemHandle.requestPermission', 'requestPermission()')}}</dt>
 <dd>Requests read or readwrite permissions for the file handle.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<h3 id="Checking_Type">Checking Type</h3>

<p>The below code allows the user to choose a file from the file picker and then tests to see whether the handle returned is a file or directory</p>

<pre class="brush: js notranslate">// store a reference to our file handle
let fileHandle;

async function getFile() {
  // open file picker
  [fileHandle] = await window.showOpenFilePicker();

  if (fileHandle.type === 'file') {
    // run file code
  } else if (fileHandle.type === 'directory')
    // run directory code
  }

}
</pre>

<h3 id="QueryRequest_Permissions">Query/Request Permissions</h3>

<p>The following asynchronous function returns true if user has granted read or readwrite permissions to the file handle. Permission is requested if not.</p>

<pre class="brush: js notranslate">// fileHandle is a FileSystemFileHandle
// withWrite is a boolean set to true if write

async function verifyPermission(fileHandle, withWrite) {
  const opts = {};
  if (withWrite) {
    opts.mode = 'readwrite';
  }

  // Check if we already have permission, if so, return true.
  if (await fileHandle.queryPermission(opts) === 'granted') {
    return true;
  }

  // Request permission to the file, if the user grants permission, return true.
  if (await fileHandle.requestPermission(opts) === 'granted') {
    return true;
  }

  // The user did not grant permission, return false.
  return false;
}
</pre>

<h3 id="Comparing_Entries">Comparing Entries</h3>

<p>The following function compares a single entry with an array of entries, and returns a new array with any matching entries removed.</p>

<pre class="brush: js notranslate">function removeMatches(fileEntry, entriesArr) {

  let newArr = entriesArr.filter( entry =&gt; !fileEntry.isSameEntry(entry) )

  return newArr;
}
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('File System Access','#api-filesystemhandle','FileSystemHandle')}}</td>
   <td>{{Spec2('File System Access')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.FileSystemHandle")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/docs/Web/API/File_System_Access_API">File System Access API</a></li>
 <li><a href="https://web.dev/file-system-access/">The File System Access API: simplifying access to local files</a></li>
</ul>
